import os
import ConfigParser
from traceback import format_exc

class CustomerConfig:
      def __init__(self, configFile, infra, language = 'en', section = ''):
            self.configFile = configFile
            self.language   = 'en' #language
            self.section    = section
            self.config     = ConfigParser.ConfigParser()
            self.config.read(configFile)

            self.infra      = infra
            self.logging    = infra.getLoggingInstance()
            self.logger     = self.logging.getLogger('meresco.configs')

            self.logger.debug('Init for customerConfig, file: '+ configFile)
#            self.logging.debug('Init for customerConfig, file: '+ configFile)

      def setDefaults(self, section, language = 'en'):
            self.section = section
            self.language= 'en'

      def setSection(self, section):
            self.section = section

      def getConfig(self):
            return self.config

      def setLanguage(self, language):
            self.language = 'en'

      def setSubst(self, substDict):
            self.substDict = substDict

      def get(self, option, default = '', section = '',substDict={}):
            self.logger.debug('Searching for option: [' + option+ '] section: [' + section+']')
            lanOption=option
            config  = self.config
            infra   = self.infra
            logger  = self.logger
#            logger.debug(infra.prpt('substDict: ', substDict))
            if (substDict == ''): substDict=self.substDict
            if (section == ''): section = self.section
#            if (self.language != 'en'): lanOption = lanOption + '_' + self.language

            try:
                  value = config.get(section, lanOption, 0, substDict)
            except:
                  self.logger.debug (format_exc())
                  try:
                        value = config.get(section, option, 0, substDict)
                  except Exception, e:

                        self.logger.debug (format_exc())
                        if (default):
                              value = default
                              logger.warning ('Warning: "' + option + '[_' + self.language + ']'  + '" NOT specified ' + 'in file: "' + self.configFile + '" section: "' + section + '". Using default value: ' + default)
                        else:
                              value = option
                              errorMessage = ''
                              for msg in e:
                                    errorMessage += msg + ' '

                              errorMessage +=  ' Error: "' + option + '[_' + self.language + ']'  + '" NOT specified ' + 'in file: "' + self.configFile + '" section: "' + self.section

                              logger.error(errorMessage)
                              raise IOError, errorMessage

            logger.debug('returning value: [' + value +']')
            return value

      def dump(self):
            s = ''
            for section in config.sections():
                  s = s + ("section: " +  section )
                  for option in config.options(section):
                        s = s + " " + option + "=" + config.get(section, option) + "\n"
            return s




